-ifndef(__RumMsg__).
-define(__RumMsg__, 1).

-record(rumMsg, {
   severity :: rumAtomLevel()
   , pid :: pid()
   , node :: node()
   , module :: module()
   , function :: atom()
   , file :: atom()
   , line :: integer()
   , metadata :: [tuple()]
   , datetime :: binary()
   , timestamp :: non_neg_integer()
   , message :: list()
   , destinations :: list()
}).

-define(newMsg(Severity, Pid, Node, Module, Function, Line, Metadata, Destinations, TimeMs, Msg),
   #rumMsg{
      severity = Severity
      , pid =Pid
      , node = Node
      , module = Module
      , function = Function
      , line =Line
      , metadata =Metadata
      , datetime = rumUtil:msToBinStr(TimeMs)
      , timestamp = TimeMs
      , message = Msg
      , destinations = Destinations
   }).
-endif.